<?php

/*
 * @component Calc Builder 
 * @copyright Copyright (C) September 2021. 
 * @license GPL 3.0 
 * This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version. 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details. 
 * See <http://www.gnu.org/licenses/>. 
 * More info www.moonsoft.es 
 * gestion@moonsoft.es
 */
// No direct access to this file
defined ( '_JEXEC' ) or die ( 'Restricted access' );

use Joomla\CMS\Version;
use Joomla\CMS\Factory;
use Joomla\CMS\Uri\Uri;

class plgSystemHikashopcalcbuildercustomInstallerScript {
	/**
	 * method to install the component
	 *
	 * @return void
	 */
	function install($parent) {
		// echo 'Install';
	}
	
	/**
	 * method to uninstall the component
	 *
	 * @return void
	 */
	function uninstall($parent) {
		// $parent is the class calling this method
		echo '<p>Thanks for using Calc Builder Hikashop Custom plugin</p>
    <p><hr/>If you have any question, problem or comment, please send us an email: <a href="mailto:gestion@moonsoft.es">gestion@moonsoft.es</a> or visit our web page <a href="https://www.moonsoft.es" target="_blank">www.moonsoft.es</a><br/>    
    </p>';
	}
	
	/**
	 * method to update the component
	 *
	 * @return void
	 */
	function update($parent) {
		// $parent is the class calling this method
		// echo '<h3>Updated</h3>';
	}
	
	/**
	 * method to run before an install/update/uninstall method
	 *
	 * @return void
	 */
	function preflight($type, $parent) {		
		if ($type != 'uninstall') {
			$jversion = new JVersion ();
			
			// Installing component manifest file version
			$this->release = $parent->getManifest()->version;
			
			// Manifest file minimum Joomla version
			$this->minimum_joomla_release = $parent->getManifest()->attributes()->version;
			
			// abort if the current Joomla release is older
			if (version_compare ( $jversion->getShortVersion(), $this->minimum_joomla_release, 'lt' )) {
				Jerror::raiseWarning ( null, 'Cannot install this version of Calcbuilder Custom plugin ('.$jversion->getShortVersion().') in a Joomla release prior to ' . $this->minimum_joomla_release );
				return false;
			} else {
				$rel = $this->release;
			}
			
			// abort if Hikashop is not installed
			$db = JFactory::getDbo ();
			/*$query="SHOW TABLES LIKE '#__hikashop_config'";
			$db->setQuery($query);
			$table=$db->loadObject();
			//$tables = JFactory::getDbo()->getTableList();
			if (count($table)<=0):
				Jerror::raiseWarning ( null, 'Please Install Hikashop before install Calcbuilder plugin');
				return false;
			endif;
			*/
			
			// abort if the component being installed is not newer than the currently installed version
			if ($type == 'update') {
				//$this->insertSchema ();
				$oldRelease = $this->getParam('version');
				$rel = $oldRelease . ' to ' . $this->release;
				$sql_updates = array();				
				if (version_compare($oldRelease, '3.1.12','lt')) {
					$sql_updates[] = "insert into #__hikashop_field(field_table, field_realname, field_namekey, 
							field_type, field_value, field_published, field_ordering, field_options, field_core, field_required, 
							field_backend, field_frontcomp, field_default, field_backend_listing, field_access, field_categories, 
							field_with_sub_categories, field_display)
							values('item', 'Calculated parameters', 'calculatedparams', 'text', '', '1', '15', 'a:12:{s:12:\"errormessage\";s:0:\"\";s:4:\"cols\";s:0:\"\";s:9:\"filtering\";s:1:\"1\";s:9:\"maxlength\";s:1:\"0\";s:4:\"rows\";s:0:\"\";s:9:\"zone_type\";s:7:\"country\";s:12:\"pleaseselect\";s:1:\"0\";s:4:\"size\";s:0:\"\";s:6:\"format\";s:0:\"\";s:5:\"allow\";s:0:\"\";s:8:\"readonly\";s:1:\"1\";s:15:\"limit_to_parent\";s:0:\"\";}', '0', '0', '1', '1', '', '0', 'all', 'all', '0', '')";
				}			
												
				foreach ( $sql_updates as $sql ) {
					$db->setQuery ( $sql );
					$db->query ();
				}
			} else {
				$rel = $this->release;
			}
		}
	}
	
	/**
	 * method to run after an install/update/uninstall method
	 *
	 * @return void
	 */
	function postflight($type, $parent) {
		
	}
	
	/*
	 * get a variable from the manifest file (actually, from the manifest cache).
	 */
	function getParam($name) {
		$db = JFactory::getDbo ();
		$db->setQuery ( 'SELECT manifest_cache FROM #__extensions WHERE element = "hikashopcalcbuilder" and type="plugin"' );
		$manifest = json_decode ($db->loadResult (),true);
		return $manifest [$name];
	}
	
	/*
	 * sets parameter values in the component's row of the extension table
	 */
	function setParams($param_array) {
		if (count ( $param_array ) > 0) {
			// read the existing component value(s)
			$db = JFactory::getDbo ();
			$db->setQuery ( 'SELECT params FROM #__extensions WHERE element = "hikashopcalcbuilder"  and type="plugin"' );
			$params = json_decode ( $db->loadResult (), true );
			// add the new variable(s) to the existing one(s)
			foreach ( $param_array as $name => $value ) {
				$params [( string ) $name] = ( string ) $value;
			}
			// store the combined new and existing values back as a JSON string
			$paramsString = json_encode ( $params );
			$db->setQuery ( 'UPDATE #__extensions SET params = ' . $db->quote ( $paramsString ) . ' WHERE element = "hikashopcalcbuilder" and type="plugin"' );
			$db->query ();
		}
	}
	
	/* insert schema entry if not present */
	function insertSchema() {
		$db = JFactory::getDbo ();
		$db->setQuery ( 'select count(*) from #__schemas where extension_id=(select extension_id from #__extensions WHERE element = "com_calcbuilder"  and type="component")' );
		$entrada = $db->loadResult ();
		$db->setQuery ( 'select count(*) from #__extensions WHERE element = "com_calcbuilder"  and type="component"' );
		$extensions = $db->loadResult ();
		// extension_id
		if ($entrada == "0" && $extensions != "0") {
			$db->setQuery ( 'insert into #__schemas (extension_id,version_id) values ((select extension_id from #__extensions WHERE element = "com_calcbuilder"  and type="component"),"2.1.0") ' );
			$db->query ();
		}
	}
}

?>